package tech.loedige;

import java.math.BigInteger;

public class Main {

    public static void main(String[] args) {
        //Persönliche Infos
        System.out.format("%-15s","Name:");
        System.out.println("Paul Lödige");
        System.out.format("%-15s","Matrikel Nr.:");
        System.out.println("15405036");
        System.out.println();

        eea(new BigInteger("3576222"), new BigInteger("117624"));
    }

    public static void eea(BigInteger a, BigInteger b){
        //Auf fehlerhafte Eingabe überprüfen
        if(a.compareTo(BigInteger.ZERO)==-0 ||  b.compareTo(BigInteger.ZERO)==-0){
            System.out.println("mind. eine der Eingaben war 0. Hiermit ist der Euklid'sche Algoithmus nicht möglich");
            return;
        }

        //Auf negative Eingabe überprüfen
        if(a.compareTo(BigInteger.ZERO)==-1 ||  b.compareTo(BigInteger.ZERO)==-1){
            System.out.println("Die Vorzeichen der Eingabe werden im Folgenden ignoriert.");
        }
        //Vorzeichen ignorieren
        a = a.abs();
        b = b.abs();

        //Reihenfolge der Eingabewerte sicherstellen
        if (a.compareTo(b)==-1){
            BigInteger storage = a;
            a = b;
            b = storage;
        }

        //Format für ordentliche Einrückung bestimmen
        int length = a.toString().length();
        String format = "%" + length + "s";

        //Header ausgeben
        printLine(a.toString(),b.toString(),"","q",format);
        for(int i = 0; i<length * 4 + 12; i++)
            System.out.print("-");
        System.out.println();


        //region Euklid'scher Algorithmus

        //Variablen definieren
        BigInteger mul_a;
        BigInteger mul_a_old;
        BigInteger mul_b;
        BigInteger mul_b_old;
        BigInteger result_old;
        BigInteger result;
        BigInteger q;
        BigInteger storage;

        //erste Zeile
        mul_a = BigInteger.ONE;
        mul_b = BigInteger.ZERO;
        result = a;
        printLine(mul_a.toString(),mul_b.toString(),result.toString(),"",format);

        //zweite Zeile
        mul_a_old = mul_a;
        mul_b_old = mul_b;
        mul_a = BigInteger.ZERO;
        mul_b = BigInteger.ONE;
        result_old = result;
        result = b;
        q = result_old.divide(result);
        printLine(mul_a.toString(),mul_b.toString(),result.toString(),q.toString(),format);

        //Algorithmus
        do{
            //new result
            storage = result;
            result = result_old.subtract(result.multiply(q));
            result_old = storage;

            //new mul_a
            storage = mul_a;
            mul_a = mul_a_old.subtract(mul_a.multiply(q));
            mul_a_old = storage;

            //new mul_b
            storage = mul_b;
            mul_b = mul_b_old.subtract(mul_b.multiply(q));
            mul_b_old = storage;

            //new q
            if(result.compareTo(BigInteger.ZERO)==1)
                q = result_old.divide(result);
            else
                q = null;

            //print
            printLine(mul_a.toString(),
                    mul_b.toString(),
                    result.toString(),
                    q != null ? q.toString() : "",
                    format);
        }while(result.compareTo(BigInteger.ZERO)==1);
        //endregion

    }

    private static void printLine(String mul_a, String mul_b, String result, String q, String format){
        System.out.format(format,mul_a);
        System.out.print("    ");
        System.out.format(format,mul_b);
        System.out.print("    ");
        System.out.format(format,result);
        System.out.print("    ");
        System.out.format(format,q);
        System.out.println();
    }
}
